Option Explicit

Class ComputerClass
 ' handles the debug log and some other bits
 Public fso, fsDebugLog, fsTellLog, timTimeRunning
 
 
 Public Property Get LastPack ()
  ' returns the iPack position to be used with aco.MoveToPack
  Dim iPack, acoPack, iLastPack
  iLastPack = 0
  For iPack = 1 To skapi.cPack - 1
   Set acoPack = skapi.AcoFromIpackIitem(iPack, iItemNil)
   If Free(acoPack) > 0 Then
   	iLastPack = iPack
   End If
  Next
  LastPack = iLastPack
 End Property

 Public Property Get FirstPack ()
  Dim iPack, acoPack, iFirstPack
  iFirstPack = 0
  For iPack = 1 To skapi.cPack - 1
   Set acoPack = skapi.AcoFromIpackIitem(iPack, iItemNil)
   If Free(acoPack) > 0 Then
   	iFirstPack = iPack
   	Exit For
   End If
  Next
  FirstPack = iFirstPack
 End Property
 
 Public Function Free (acoPack) 
  Free = acoPack.cItemMax - acoPack.cItemContents
 End Function

 Public Property Get TotalFree ()
  Dim iPack, acoPack, iFree
  iFree = 0
  For iPack = 0 To skapi.cPack - 1
   Set acoPack = skapi.AcoFromIpackIitem(iPack, iItemNil)
   iFree = iFree + Free(acoPack)
  Next
  TotalFree = iFree
 End Property
 
 Public Sub ClearMainPack ()
  Dim coMainPack, acfStacks, acoTargetPack, acoItem, tTimeOut, iTries
  Dim tProcessTimer
  Set tProcessTimer = skapi.TimerNew()
  Set acfStacks = skapi.AcfNew
  acfStacks.olc = olcInventory
  Set coMainPack = acfStacks.CoacoGet(skapi.acoChar.coacoContents)
  Call coMainPack.Sort(skapi.sortbyName)
  Set tTimeOut = skapi.TimerNew()
  If coMainPack.Count > 0 And LastPack > 0 Then
  	Out "Clearing main pack."
  	Set tTimeOut = skapi.TimerNew()
  	For Each acoItem In coMainPack
  	 If LastPack > 0 Then
   	 	For iTries = 1 To 3
    	  	 Handler.ExpectMove  = acoItem
    	  	 tTimeOut.cmsec = 0
    	  	 If acoItem.szName = "Pyreal" Then
    	  		Call acoItem.MoveToPack(LastPack, 0, True)
    	  	 Else
    	 		Call acoItem.MoveToPack(FirstPack, 0, True)
    	  	 End If
    	  	 Do Until Handler.MoveComplete Or Handler.Warning Or tTimeOut.cmsec > 3000
    	   	  skapi.WaitEvent(100)
    	   	  If Handler.Warning Then
    	   	  	Out "Handler has thrown a warning. Terminating Sub ClearMainPack."
    	   	  	Exit Sub
    	   	  End If
    	  	 Loop
    	  	 If Handler.MoveComplete Then Exit For
    	  	Next
    	 Else
    	  	Exit For
    	 End If
    	Next
  Else
  	If Computer.LastPack = 0 Then Out "No more free side packs"
  	If coMainPack.Count = 0 Then Out "No items in main pack."
  End If
  Out "Sub ClearMainPack complete in: " & ShowTime(tProcessTimer.cmsec)
 End Sub
 
 Public Function AllInvItems ()
  Dim acfInvItems
  Set acfInvItems = skapi.AcfNew()
  acfInvItems.olc = olcInventory
  Set AllInvItems = acfInvItems.CoacoGetSorted(skapi.sortbyName)
 End Function
 
 Public Function FilterPartials (coItems)
  ' returns a coaco containing one arbitrary item of each name that needs to be stacked
  Dim coPartials, dUniqueNames, iItem, aNames
  Set coPartials = skapi.CoacoNew()
  Set dUniqueNames = CreateObject("Scripting.Dictionary")
  dUniqueNames.CompareMode = vbTextCompare
  For Each iItem in coItems
   If iItem.cItemMaxStack > iItem.cItemStack Then
   	If dUniqueNames.Exists(iItem.szName) Then
   		dUniqueNames.Item(iItem.szName) = True
   	Else
   		dUniqueNames.Add iItem.szName, False
   	End If
   End If
  Next
  aNames = dUniqueNames.Keys
  For iItem = 0 To dUniqueNames.Count - 1
   If dUniqueNames.Item(aNames(iItem)) Then
   	coPartials.AddAco(skapi.AcoFindInInv(aNames(iItem)))
   End If
  Next
  Set FilterPartials = coPartials
 End Function
 
 Public Sub StackAll ()
  ' this sub SHOULD stack all stackable items in your inventory
  ' but it makes no distinction as to what pack the merged stacks
  ' reside in, this is more or less arbitrary
  ' it will only try to move an item 2 times
  Dim coPartials, coCurrentPartial
  Dim acfPartials
  Dim iItem, sItem, iUsed, iTries
  Dim tTimeOut
  Dim tProcessTimer
  Set tProcessTimer = skapi.TimerNew()
  Set tTimeOut = skapi.TimerNew()
  Set acfPartials = skapi.AcfNew()
  acfPartials.olc = olcInventory
  Out "Stacking all stackable items."
  Set coPartials = FilterPartials(AllInvItems)
  For Each iItem in coPartials
   acfPartials.szName = iItem.szName
   acfPartials.cItemStackMax = iItem.cItemMaxStack - 1
   Set coCurrentPartial = acfPartials.CoacoGet
   Do While coCurrentPartial.Count > 1
    For iUsed = 1 To coCurrentPartial.Count - 1
     If coCurrentPartial(0).cItemStack = coCurrentPartial(0).cItemMaxStack Then Exit For ' iUsed for loop
     For iTries = 1 To 2
      If coCurrentPartial(0).cItemStack + coCurrentPartial(iUsed).cItemStack < iItem.cItemMaxStack Then
      	Handler.ExpectAdjust coCurrentPartial(0), Nothing
      Else
      	Handler.ExpectAdjust coCurrentPartial(0), coCurrentPartial(iUsed)
      End If
      tTimeOut.cmsec = 0
      coCurrentPartial(iUsed).MoveToStack(coCurrentPartial(0))
      Do Until Handler.AdjustComplete Or Handler.Warning Or tTimeOut.cmsec > 3000
       skapi.WaitEvent(100)
       If Handler.Warning Then
       		Out "Handler has thrown a warning. Terminating Sub StackAll."
  	 	Exit Sub
       End If
      Loop
      If Handler.AdjustComplete Then Exit For
     Next ' iTries
    Next ' iUsed
    ' we get here for a variety of reasons, so we'll refresh our data
    Set coCurrentPartial = acfPartials.CoacoGet
   Loop
  Next ' iItem In coPartials
  Out "Sub Stackall complete in: " & ShowTime(tProcessTimer.cmsec)
 End Sub

 Public Property Get Running ()
  Running = timTimeRunning.cmsec
 End Property
 
 Public Sub Out (szText)
  Call skapi.OutputLine("MPB: " & szText)
  fsDebugLog.WriteLine "[" & Now & "]" & szText
 End Sub
 
 Public Function OnTell(acoFrom, acoTo, szMsgText)
  If acoFrom <> ArchmageName And acoFrom <> HealerName Then
  	fsTellLog.WriteLine "[" & Now & "]{" & acoFrom.szName & "}: " & szMsgText
  End If
 End Function
 
 Public Sub Register ()
  Call skapi.AddHandler(evidOnTell, Computer)
  Call skapi.AddHandler(evidOnCommand, Computer)
 End Sub
 
 Private Sub Class_Initialize()
  Set fso = CreateObject("Scripting.FileSystemObject")
  Set fsDebugLog = fso.OpenTextFile(szScriptPath & "DebugLog.txt",8,True,0)
  Set fsTellLog = fso.OpenTextFile(szScriptPath & skapi.szWorld & " - " & skapi.szName & " Tells.txt",8,True,0)
  Set timTimeRunning = skapi.TimerNew
 End Sub

 Private Sub Class_Terminate()  
  Call skapi.RemoveHandler(evidOnTell, Computer)
  Call skapi.RemoveHandler(evidOnCommand, Computer)
  fsDebugLog.Close
  fsTellLog.Close
  Set fsDebugLog = Nothing
  Set fsTellLog = Nothing
  Set fso = Nothing
  Set timTimeRunning = Nothing
 End Sub
End Class