' ***************************************
' ** Morkai's Plat Bot: Health Potions **
' ***************************************
' 
' Most code by Morkai the Red
' Some code by KGober (possibly the most important functions)
' Some inspiration by KGober and Ogz
Option Explicit
' ----- BEGIN CONFIGURATION SECTION -----
' You must change this to where YOU have it installed!
'-- Script Path, change this to whatever path you have this file in
Public Const szScriptPath = "E:\AC\Scripts\Rithwic Potions\"
'--

'-- Work Location
' 1 = work at healer (this is not recommended)
' 2 = work at home
' 3 = work at mansion
' if you need to move away from your covenant stone for whatever reason, make UseWorkplaceRoute True
' and provide a route to wherever you need to go, the file must be named "Workplace.route"

public const UseWorkplaceRoute = False
public const WorkLocation = 2

'-- Profits
' buy anything you want with your profits, exact name and exact price of ONE
Public Const BuyItem = "Trade Note (250,000)"
Public Const BuyItemPrice = 287500
'Public Const BuyItem = "Platinum Scarab"
'Public Const BuyItemPrice = 44000
'--

'-- Stock levels and whatnot
' the number of healing kits you need to produce 100 potions
' does not need to be a whole number, being off a little won't hurt you
Public Const KitsPer100 = 2.5

' the absolute minimum hp level before healing, must be a positive whole number
Public Const DraughtHPMin = 60

' hopefully you won't have to adjust this, since it cuts into profits
Public Const PotsPerKit = 1

' BatchSize is the number of Health Draughts to buy at one time
' Make sure you don't get too heavy
' Potions of Healing are sold when Draughts are bought
Public Const BatchSize = 300

' Number of realgar peas to buy at the Retreat
' Raise this for low alchemy skill, lower it for limited pack space
' (the default value of 240 is for high skill and maximum space)
' having too many will not impact profits significantly, but too few will
Public Const PeaStock = 240
'--

'-- Game Changes
Public Const ProductName = "Potion of Healing"
Public Const SellPrice = 450
Public Const HealKitName = "Plain Healing Kit"
Public Const HealKitPrice = 68
Public Const StamPotName = "Stamina Elixir"
Public Const StamPotPrice = 203
Public Const DraughtName = "Health Draught"
Public Const DraughtPrice = 270
Public Const DraughtHPCost = 21
Public Const PeaName = "Realgar Pea"
Public Const PeaPrice = 687.5
'--

' ----- END CONFIGURATION SECTION -----

' Keep your hands off everything below this point unless you REALLY know
' what you're doing! That probably means YOU.

' Turns out that lying down for stamina and using a stamina elixer cost
' the same in the long run, since any time not spent producing is money lost
' these variables are retired, but i've left them in for some reason i've now forgotten
Public Const HealStaminaMin = 20 ' you will begin to rest when stamina below this level
Public Const HealStaminaMax = 160 ' you will get back to work when stamina over this level

Public Const ArchmageName = "Sialla Jiro"
Const ArchmageLB = &H56600155&


Public Const HealerName = "Brisin the Healer"
Const HealerLB = &Hc88c0020&


public WorkplaceLB

Public Const InfusName = "Victual Infusion"
Public Const CInfusName = "Concentrated Victual Infusion"

Public Computer, Handler

Dim BuyTimer
Set BuyTimer = skapi.TimerNew()
BuyTimer.tag = 0

Dim T
Set T = skapi.TimerNew()

Dim MainPack
Set MainPack = skapi.acoChar

' pixel tests for chat window size
Dim ChatExpanded
Set ChatExpanded = skapi.PxtNew(0, -92, 2064, 6218)

' pixel tests for green glow under name of selected item (lower right corner of AC UI)
Dim CurrentSelectionMulti, CurrentSelectionSingleOK, CurrentSelectionMultiOK
Set CurrentSelectionMulti = skapi.PxtNew(-231, -62, 0, 3223601)
Set CurrentSelectionSingleOK = skapi.PxtNew(-169, -61, 1588248, 0)
Set CurrentSelectionMultiOK = skapi.PxtNew(-213, -36, 3239225, 528408)

Public iCountHealsTotal, iCountMakesTotal
iCountHealsTotal = 0
iCountMakesTotal = 0

Public iStartMoney, iNowMoney, iMinutes, iSeconds

skapi.SetIdleTime(360000)

Sub Main  ()
 Dim iState
 Set Computer = New ComputerClass
 Set Handler = New HandlerClass
 Call Computer.Register
 Call Handler.Register
 iStartMoney = CurrentMoneyLevel
 WorkplaceLb = &H0000000&
 iState = 0
 Call Part4
 Computer.Out "All initialization complete. Starting State Machine."
 Do
  Select Case (iState)
   Case 0: iState = Part0() ' Decide what to do and navigate to where you need to be
   Case 1: iState = Part1() ' Buy Draughts and Heal Kits
   Case 2: iState = Part2() ' Make Health Potions
   Case 3: iState = Part3() ' Sell Potions
   Case 4: iState = Part4() ' Defragment Inventory
   Case 5: iState = Part5() ' Buy Peas and Plats
   Case 6: iState = Part6() ' Log off if something goes terribly wrong
  End Select
 Loop Until iState = -1
 Computer.Out "State Machine has exited."
 Set Handler = Nothing
 Set Computer = Nothing
End Sub

Function Part0 ()
 ' decision making process and controls navigation
 If Handler.Warning Then
 	Computer.Out "Handler has thrown a warning. Terminating Macro."
 	Part0 = 6
  	Exit Function
 End If
 Computer.Out "Total Running Time: " & ShowTime(Computer.Running)
 If Computer.TotalFree < 12 Then
 	Call NavigateArchmage ()
 	Part0 = 5
 	Exit Function
 End If
 ' if have product to sell, nav to healer and sell
 If skapi.cItemOfKindInInv(DraughtName) > 0 And skapi.cItemOfKindInInv(HealKitName) > 0 And skapi.cItemOfKindInInv(StamPotName) > 0 And (skapi.cItemOfKindInInv(PeaName) > 0 Or skapi.cItemOfKindInInv(CInfusName) > 0 Or skapi.cItemOfKindInInv(InfusName) > 0) Then
 	Call NavigateWorkplace ()		' have all supplies to make potions
 	Part0 = 2				' get to work!
 Else
	If skapi.cItemOfKindInInv(ProductName) > 0 Then
 		Call NavigateHealer ()				' have product on hand to sell
 		Part0 = 3					'
 	Else
 		If skapi.cItemOfKindInInv(PeaName) > 0 Or skapi.cItemOfKindInInv(CInfusName) > 0 Or skapi.cItemOfKindInInv(InfusName) > 0  Then
 			Call NavigateHealer ()		' have peas or infusions but no draughts
 			Part0 = 1			' head for the healer to buy more
 		Else
	 		Call NavigateArchmage ()	' no peas or infusions at all
  			Part0 = 5			' head for the archmage
 		End If
 	End If
 End If
End Function

Function Part1 ()
 ' Buy Health Draughts and Heal Kits based on pre-defined stock levels
 Dim obj, tTimeOut, iBuyDraught, iBuyKit, iBuyStam, coProduct, acfProduct, acoItem, iPy, tProcessTimer
 If Handler.Warning Then Exit Function
 Set tProcessTimer = skapi.TimerNew()
 Set tTimeOut = skapi.TimerNew()
 Computer.Out "Buying " & DraughtName & " from " & HealerName & "."
 Do
  Set obj = skapi.AcoFromSz(HealerName)
  Handler.ExpectVendor  = obj
  tTimeOut.cmsec = 0
  If Not obj Is Nothing Then
  	obj.Use
  	Do
  	 Call skapi.WaitEvent (100)
  	 If Handler.Warning Then
  	 	Computer.Out "Handler has thrown a warning. Terminating Buy Process."
  	 	Part1 = 0
  		Exit Function
  	 End If
  	Loop Until Handler.VendorOpen Or tTimeOut.cmsec > 5000
  End If
 Loop Until Handler.VendorOpen
 iBuyDraught = BatchSize - skapi.cItemOfKindInInv(DraughtName)
 iBuyKit = (KitsPer100 * (BatchSize / 100)) - (skapi.cItemOfKindInInv(HealKitName) - 1)
 If iBuyKit / 1 > iBuyKit \ 1 Then iBuyKit = (iBuyKit \ 1) + 1
 If (iBuyDraught * DraughtPrice) > (skapi.cpycash - (iBuyKit * HealKitPrice)) Then
 	' since heal kits are cheap, we won't bother with crazy calculations, just buy the extras this time
 	iBuyDraught = (skapi.cpycash - (iBuyKit * HealKitPrice)) \ DraughtPrice
 End If
 If iBuyDraught > 0 Then Call Buy (DraughtName, DraughtPrice, iBuyDraught)
 If iBuyKit > 0 Then Call Buy (HealKitName, HealKitPrice, iBuyKit)
 iBuyStam = (skapi.cItemOfKindInInv(HealKitName) * PotsPerKit) - skapi.cItemOfKindInInv(StamPotName)
 If iBuyStam / 1 > iBuyStam \ 1 Then iBuyStam = (iBuyStam \ 1) + 1
 If iBuyStam > 0 Then Call Buy (StamPotName, StamPotPrice, iBuyStam)
 Computer.Out "Done Buying " & DraughtName & " from " & HealerName & "."
 Computer.Out "Buy Process complete in: " & ShowTime(tProcessTimer.cmsec)
 Part1 = 4 ' next state is defragment
End Function

Function Part2 ()
 ' Make Potions of Healing, use Plain Healing Kits when needed
 '
 '
 Dim acoAlembic, acoEyedropper
 Dim acfAllKits, acfAllInfusions, acfAllConcentrates, acfAllDraughts, acfAllPeas, acfAllStams
 Dim iCount, iTries, iCounterHeals, iCounterMakes
 Dim tTmr, tProcessTimer
 
 If Handler.Warning Then Exit Function
 Computer.Out "Making " & ProductName & "."
 Set tProcessTimer = skapi.TimerNew()
 Set tTmr = skapi.TimerNew()
 
 Set acfAllKits = skapi.AcfNew()
 acfAllKits.olc = olcInventory
 acfAllKits.szName = HealKitName

 Set acfAllStams = skapi.AcfNew()
 acfAllStams.olc = olcInventory
 acfAllStams.szName = StamPotName

 Set acfAllInfusions = skapi.AcfNew()
 acfAllInfusions.olc = olcInventory
 acfAllInfusions.szName = InfusName

 Set acfAllConcentrates = skapi.AcfNew()
 acfAllConcentrates.olc = olcInventory
 acfAllConcentrates.szName = CInfusName

 Set acfAllDraughts = skapi.AcfNew()
 acfAllDraughts.olc = olcInventory
 acfAllDraughts.szName = DraughtName

 Set acfAllPeas = skapi.AcfNew()
 acfAllPeas.olc = olcInventory
 acfAllPeas.szName = PeaName
 
 iCounterHeals = 0
 iCounterMakes = 0

 Set acoAlembic = skapi.AcoFindInInv("Alembic")
 If acoAlembic Is Nothing Then
 	Computer.Out "Can't find Alembic. Exiting."
 	Part2 = 6
 	Exit Function
 End If
 Set acoEyedropper = skapi.AcoFindInInv("Eye Dropper")
 If acoEyedropper Is Nothing Then
 	Computer.Out "Can't find Eye Dropper. Exiting."
 	Part2 = 6
 	Exit Function
 End If

 Do While skapi.cItemOfKindInInv(DraughtName) > 0 _
      And skapi.cItemOfKindInInv(StamPotName) > 0 _
      And skapi.cItemOfKindInInv(HealKitName) > 0 _
      And (skapi.cItemOfKindInInv(InfusName) > 0 Or skapi.cItemOfKindInInv(CInfusName) > 0 Or skapi.cItemOfKindInInv(PeaName) > 0)
  If skapi.cItemOfKindInInv(InfusName) = 0 Then
  	' We have no Infusions
  	If skapi.cItemOfKindInInv(CInfusName) = 0 Then
  		' We have no Concentrated Infusions
  		Handler.ExpectCraft
  		Call Handler.ExpectAddsz(CInfusName)
  		tTmr.cmsec = 0
  		acoAlembic.UseOnAco(SmallStack(acfAllPeas.CoacoGet()))
  		Do Until (Handler.CraftComplete And Handler.CraftSuccess And Handler.AddComplete) _
  		Or (Handler.CraftComplete And Not(Handler.CraftSuccess)) Or tTmr.cmsec > 10000
  		 skapi.WaitEvent(100)
  		 If Handler.Warning Then
  		 	Computer.Out "Handler has thrown a warning. Terminating Make Process."
  		 	Part2 = 0
  		 	Exit Function
  		 End If
  		Loop
  		If Computer.Free(MainPack) < 2 Then Call Part4
  	Else
  		' We have Concentrated Infusions
  		Handler.ExpectCraft
  		Call Handler.ExpectAddsz(InfusName)
  		tTmr.cmsec = 0
  		acoEyedropper.UseOnAco(SmallStack(acfAllConcentrates.CoacoGet()))
  		Do Until (Handler.CraftComplete And Handler.CraftSuccess And Handler.AddComplete) _
  		Or (Handler.CraftComplete And Not(Handler.CraftSuccess)) Or tTmr.cmsec > 10000
  		 skapi.WaitEvent(100)
  		 If Handler.Warning Then
  		 	Computer.Out "Handler has thrown a warning. Terminating Make Process."
  		 	Part2 = 0
  		 	Exit Function
  		 End If
  		Loop
  		If Computer.Free(MainPack) < 2 Then Call Part4
  	End If
  Else
  	' We have Infusions
  	Do Until skapi.healthCur > DraughtHPMIn + DraughtHPCost Or Handler.Warning
  	 If skapi.staminaCur < HealStaminaMin Then
'  	 	Call skapi.Keys("b")
'  	 	Do Until skapi.staminaCur > HealStaminaMax
'  	 	 skapi.WaitEvent(100)
'  	 	 If Handler.Warning Then
'  	 	 	Computer.Out "Handler has thrown a warning. Terminating Make Process."
'  	 	 	Part2 = 0
'  	 	 	Exit Function
'  	 	 End If
'  	 	Loop
  	 	tTmr.cmsec = 0
  	 	SmallStack(acfAllStams.CoacoGet()).Use
  	 	Do Until tTmr.cmsec > 3000
  	 	 skapi.WaitEvent(100)
  	 	 If Handler.Warning Then
  	 	 	Computer.Out "Handler has thrown a warning. Terminating Make Process."
  	 	 	Part2 = 0
  	 	 	Exit Function
  	 	 End If
  	 	Loop
  	 End If
  	 Handler.ExpectCraft
  	 tTmr.cmsec = 0
  	 Call LeastUses(acfAllKits.CoacoGet()).UseOnAco(MainPack)
	 Do Until Handler.CraftComplete Or tTmr.cmsec > 10000
	   skapi.WaitEvent(100)
	   If Handler.Warning Then
	   	Computer.Out "Handler has thrown a warning. Terminating Make Process."
	   	Part2 = 0
  	 	Exit Function
  	   End If
	 Loop
  	 iCounterHeals = iCounterHeals + 1
  	 iCountHealsTotal = iCountHealsTotal + 1
'  	 If iCounterHeals \ 5 = iCounterHeals / 5 Then
'  	 	Call skapi.Keys("{Right}", kmoDown)
'	  	Computer.Out iCounterHeals & " heals this cycle, " & iCountHealsTotal & " total."
'	  	Call skapi.Keys("{Right}", kmoUp)
'	 End If
  	Loop
  	' We are healed and ready to craft our item
  	Handler.ExpectCraft
  	Call Handler.ExpectAddsz(ProductName)
  	tTmr.cmsec = 0
  	Call SmallStack(acfAllInfusions.CoacoGet()).UseOnAco(SmallStack(acfAllDraughts.CoacoGet()))
   	Do Until (Handler.CraftComplete And Handler.CraftSuccess And Handler.AddComplete) _
  	Or (Handler.CraftComplete And Not(Handler.CraftSuccess)) Or tTmr.cmsec > 10000
'	Do Until Handler.CraftComplete Or tTmr.cmsec > 5000
  	 skapi.WaitEvent(100)
  	 If Handler.Warning Then
  	 	Computer.Out "Handler has thrown a warning. Terminating Make Process."
  	 	Part2 = 0
  	 	Exit Function
  	 End If
  	Loop
  	iCounterMakes = iCounterMakes + 1
   	iCountMakesTotal = iCountMakesTotal + 1
'   	If iCounterMakes \ 10 = iCounterMakes / 10 Then
'   		'Call skapi.Keys("{Left}", kmoDown)
'   		Computer.Out iCounterMakes & " makes this cycle, " & iCountMakesTotal & " total."
'   		'Call skapi.Keys("{Left}", kmoUp)
'   	End If
   	If iCounterMakes \ 50 = iCounterMakes / 50 Then
   		iNowMoney = CurrentMoneyLevel
  		If iStartMoney < iNowMoney Then
  			iMinutes = Computer.Running \ 60000
  			iSeconds = Computer.Running \ 1000
  			If iMinutes = 0 Then iMinutes = 1
  			Computer.Out "Total Running Time: " & ShowTime(Computer.Running)
  			Computer.Out "Total Profit: " & Int(iNowMoney - iStartMoney) & "py."
  			Computer.Out "Pyreals Per Hour: " & Int(60 * ((iNowMoney - iStartMoney) / iMinutes))
  			Computer.Out "Craft Attempts: " & iCountMakesTotal
  			Computer.Out "Crafts Per Minute: " & Int(60 * (iCountMakesTotal / iSeconds))
  			Computer.Out "Heal Attempts: " & iCountHealsTotal
  		End If
  	End If
  	If Computer.Free(MainPack) = 0 Then Call Part4
  End If
 Loop
 Computer.Out "Make Process complete in: " & ShowTime(tProcessTimer.cmsec)
 Part2 = 4
End Function

Function Part3 ()
 ' Sell Potions
 Dim obj, tTimeOut, coProduct, acfProduct, acoItem, iPy, tProcessTimer
 If Handler.Warning Then Exit Function
 Computer.Out "Selling " & ProductName & "."
 Set tProcessTimer = skapi.TimerNew()
 Set tTimeOut = skapi.TimerNew()
 Do
  Set obj = skapi.AcoFromSz(HealerName)
  Handler.ExpectVendor  = obj
  tTimeOut.cmsec = 0
  If Not obj Is Nothing Then
  	obj.Use
  	Do
  	 Call skapi.WaitEvent (100)
  	 If Handler.Warning Then
  	 	Computer.Out "Handler has thrown a warning. Terminating Sell Process."
  	 	Part3 = 0
  	 	Exit Function
  	 End If
  	Loop Until Handler.VendorOpen Or tTimeOut.cmsec > 5000
  End If
 Loop Until Handler.VendorOpen
 Call skapi.Keys("{F11}")
 Call skapi.Keys("{F12}")
 Call MouseClickExpandChat()
 Set acfProduct = skapi.AcfNew ()
 acfProduct.szName = ProductName
 acfProduct.olc = olcInventory
 Set coProduct = acfProduct.CoacoGet()
 iPy = 0
 For Each acoItem In coProduct
   iPy = iPy + SellPrice * acoItem.cItemStack
   Call acoItem.MoveToStack(obj)
 Next
 Handler.ExpectPyreals iPy
 Call MouseClickSellAll()
 tTimeOut.cmsec = 0
 Do Until Handler.PyrealsAdded Or tTimeOut.cmsec > 10000
  Call skapi.waitevent()
  If Handler.Warning Then
  	Computer.Out "Handler has thrown a warning. Terminating Sell Process."
  	Part3 = 0
  	Exit Function
  End If
 Loop
 Computer.Out "Sell Process complete in: " & ShowTime(tProcessTimer.cmsec)
 If skapi.cItemOfKindInInv(ProductName) > 0 Then
 	Part3 = 3
 Else
 	Part3 = 1 ' next state is buy stock
 End If
End Function


Function Part4 ()
 ' clean up the main pack and shove full stacks of anything into side packs
 If Handler.Warning Then
 	Computer.Out "Handler has thrown a warning. Terminating Defragment Process."
 Else
 	Call Computer.StackAll
 	Call Computer.ClearMainPack
 End If
 Part4 = 0 ' next state is decision
End Function

Function Part5 ()
 ' buy peas and plats
 Dim obj, tTimeOut, iBuy, tProcessTimer
 Computer.Out "Buying " & PeaName & " and " & BuyItem & " from " & ArchmageName & "."
 Set tProcessTimer = skapi.TimerNew()
 Set tTimeOut = skapi.TimerNew()
 Do
  Set obj = skapi.AcoFromSz(ArchmageName)
  Handler.ExpectVendor = obj
  tTimeOut.cmsec = 0
  If Not obj Is Nothing Then
  	obj.Use
  	Do
  	 Call skapi.WaitEvent (100)
  	 If Handler.Warning Then
  	 	Computer.Out "Handler has thrown a warning. Terminating Buy Process."
  	 	Part5 = 0
  	 	Exit Function
  	 End If
  	Loop Until Handler.VendorOpen Or tTimeOut.cmsec > 5000
  End If
 Loop Until Handler.VendorOpen
 iBuy = PeaStock - skapi.cItemOfKindInInv(PeaName)
 If iBuy > 0 Then Call Buy (PeaName, PeaPrice, iBuy)
 iBuy = skapi.cpycash \ BuyItemPrice
 'iBuy = 10
 If iBuy > 0 Then Call Buy (BuyItem, BuyItemPrice, iBuy)
 Computer.Out "Buy Process complete in: " & ShowTime(tProcessTimer.cmsec)
 Part5 = 4
End Function

Function Part6 ()
 ' something's really fucked up, time to log off and exit macro
 If skapi.plig > 1 Then Call skapi.Logout
 Part6 = -1 ' exit program
End Function

Function CurrentMoneyLevel ()
 CurrentMoneyLevel = skapi.cpycash + (BuyItemPrice * skapi.cItemOfKindInInv(BuyItem))_
 				   + (SellPrice * skapi.cItemOfKindInInv(ProductName))_
 				   + (HealKitPrice * skapi.cItemOfKindInInv(HealKitName))_
 				   + (StamPotPrice * skapi.cItemOfKindInInv(StamPotName))_
 				   + (DraughtPrice * skapi.cItemOfKindInInv(DraughtName))_
 				   + (PeaPrice * skapi.cItemOfKindInInv(PeaName))_
 				   + (PeaPrice * skapi.cItemOfKindInInv(CInfusName))_
 				   + (skapi.cItemOfKindInInv(InfusName) * Int(PeaPrice / 50))
End Function

Function ShowTime (msec)
 Dim szTime, iPart
 ' Hours
 iPart = msec \ 3600000
 szTime = iPart & ":"
 msec = msec - iPart * 3600000
 ' Minutes
 iPart = msec \ 60000
 If iPart > 9 Then
 	szTime = szTime & iPart & ":"
 Else
 	szTime = szTime & "0" & iPart & ":"
 End If
 msec = msec - iPart * 60000
 ' Seconds
 iPart = msec \ 1000
 If iPart > 9 Then
 	szTime = szTime & iPart & "."
 Else
 	szTime = szTime & "0" & iPart & "."
 End If
 msec = msec - iPart * 1000
 If msec > 99 Then
 	szTime = szTime & msec
 Else
 	If msec > 9 Then
 		szTime = szTime & "0" & msec
 	Else
 		szTime = szTime & "00" & msec
 	End If
 End If
 ShowTime = szTime
End Function

Public Function SmallStack (coItem)
 Dim acoSmallest, i
 Set acoSmallest = coItem(0)
 If coItem.Count > 1 Then
 	For i = 1 To coItem.Count - 1
 	 If acoSmallest.cItemStack > coItem(i).cItemStack Then Set acoSmallest = coItem(i)
 	Next
 End If
 Set SmallStack = acoSmallest
End Function
Public Function LeastUses (coItem)
 Dim acoLeast, i
 Set acoLeast = coItem(0)
 If coItem.Count > 1 Then
 	For i = 1 To coItem.Count - 1
 	 If acoLeast.cUseLeft > coItem(i).cUseLeft Then Set acoLeast = coItem(i)
 	Next
 End If
 Set LeastUses = acoLeast
End Function

 
'-- stolen functions to support other stolen functions
Function Min(a, b)
  If (a <= b) Then
    Min = a
  Else
    Min = b
  End If
End Function

Function Max(a, b)
  If (a >= b) Then
    Max = a
  Else
    Max = b
  End If
End Function

Function Ceil(x)
  If (x = Int(x)) Then
    Ceil = x
  Else
    Ceil = Int(x + 1)
  End If
End Function



Sub Buy(name, cost, count)
  Dim markup, mcoll, obj, filt, coll, c, ct, coBuying
  Dim tArmor, tBooks, tClothing, tContainers, tFood, tGems, tJewelry, tKeys, tMisc
  Dim tServices, tComps, tNotes, tWeapons, tStones, tMagic, tAlch, tCook, tFletch
  markup = Handler.LastMerchantMarkup
  Set mcoll = Handler.LastMerchantCoaco
  For Each obj In mcoll					' enumerate all categories in stock
    Select Case (obj.szMcm)
      Case "Armor": tArmor = 1
      Case "Books, Paper": tBooks = 1
      Case "Clothing": tClothing = 1
      Case "Containers": tContainers = 1
      Case "Food": tFood = 1
      Case "Gems": tGems = 1
      Case "Jewelry": tJewelry = 1
      Case "Keys, Tools": tKeys = 1
      Case "Miscellaneous": tMisc = 1
      Case "Services": tServices = 1
      Case "Spell Components": tComps = 1
      Case "Trade Notes": tNotes = 1
      Case "Weapons": tWeapons = 1
      Case "Mana Stones": tStones = 1
      Case "Magic Items": tMagic = 1
      Case "Alchemical Items": tAlch = 1
      Case "Cooking Items": tCook = 1
      Case "Fletching Items": tFletch = 1
    End Select
  Next
  Set filt = skapi.AcfNew()				' locate item to be purchased
  filt.szName = name
  If Not Left(Name, 10) = "Trade Note" Then
  	filt.cpyMin = Int(cost / markup)
  	filt.cpyMax = Ceil(cost / markup)
  End If
  Set coll = filt.CoacoGet(mcoll)
  If (coll.Count = 0) Then
    Computer.Out "This merchant doesn't sell " & name & "s for " & FormatNumber(cost, 0) & " pyreals."
  Else
    Set obj = coll.Item(0)				' locate which line in the merchant category list to choose
    Select Case (obj.szMcm)
      Case "Armor": c = tArmor
      Case "Books, Paper": c = tArmor + tBooks
      Case "Clothing": c = tArmor + tBooks + tClothing
      Case "Containers": c = tArmor + tBooks + tClothing + tContainers
      Case "Food": c = tArmor + tBooks + tClothing + tContainers + tFood
      Case "Gems": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems
      Case "Jewelry": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry
      Case "Keys, Tools": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys
      Case "Miscellaneous": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys + tMisc
      Case "Services": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys + tMisc + tServices
      Case "Spell Components": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys + tMisc + tServices + tComps
      Case "Trade Notes": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys + tMisc + tServices + tComps + tNotes
      Case "Weapons": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys + tMisc + tServices + tComps + tNotes + tWeapons
      Case "Mana Stones": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys + tMisc + tServices + tComps + tNotes + tWeapons + tStones
      Case "Magic Items": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys + tMisc + tServices + tComps + tNotes + tWeapons + tStones + tMagic
      Case "Alchemical Items": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys + tMisc + tServices + tComps + tNotes + tWeapons + tStones + tMagic + tAlch
      Case "Cooking Items": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys + tMisc + tServices + tComps + tNotes + tWeapons + tStones + tMagic + tAlch + tCook
      Case "Fletching Items": c = tArmor + tBooks + tClothing + tContainers + tFood + tGems + tJewelry + tKeys + tMisc + tServices + tComps + tNotes + tWeapons + tStones + tMagic + tAlch + tCook + tFletch
    End Select
    Call skapi.Keys("{F11}")				' set up screen so that buttons are at expected coordinates
    Call skapi.Keys("{F12}")
    Call MouseClickExpandChat()
    Call MouseClickMerchantTab(1)
    If (BuyTimer.tag <> c) Or (BuyTimer.cmsec > 5000) Then
      Call MouseClickMerchantCategoryButton()	' choose proper category
      Call MouseClickMerchantCategory(c)
    End If
    BuyTimer.tag = c
    ct = count
    if (obj is nothing) or (t is nothing) then
        computer.out "Ogz's Patch > Error with vendor, aborting for retry."
        exit sub
    end if
    Do While (ct > 0)
      c = Min(ct, obj.citemMaxStack)
      Do
        'Computer.Out "Selecting Aco"
        Call skapi.SelectAco(obj)				' select item
        'Call skapi.Sleep(200)
        T.cmsec = 0
        Do
          'Computer.Out "Waiting until Aco is selected"
          Call skapi.waitevent(100)
  	  If Handler.Warning Then
  	 	Computer.Out "Handler has thrown a warning. Terminating Sub Buy."
  	 	Exit Sub
  	  End If
        Loop Until skapi.AcoSelected = obj Or T.cmsec > 5000
      Loop Until skapi.AcoSelected = obj
      'Computer.Out "Aco has been selected"
      If (c > 1) Then
        Call skapi.Keys(cmidSplitSelected)					' specify how many
        Call skapi.Keys(CStr(c))
      End If
      ct = ct - c
      Call Handler.ExpectAdd(obj.szName, 1)
      T.cmsec = 0
      Call MouseClickAddToList()				' buy
    Loop
    Call MouseClickMerchantTab(2)
    Call MouseClickSellAll()
    Do
     Call skapi.WaitEvent(100)
     If Handler.Warning Then
     	Computer.Out "Handler has thrown a warning. Terminating Sub Buy."
     	Exit Sub
     End If
    Loop Until Handler.AddComplete Or T.cmsec > 10000
    Handler.ResetExpectAdd
    BuyTimer.cmsec = 0
  End If
  Set coll = Nothing
  Set filt = Nothing
  Set obj = Nothing
  Set mcoll = Nothing
End Sub
Function CurrentSelectionOK()
  If (CurrentSelectionMulti.FCheck()) Then
    CurrentSelectionOK = CurrentSelectionMultiOK.FCheck()
  Else
    CurrentSelectionOK = CurrentSelectionSingleOK.FCheck()
  End If
End Function
Sub MouseClickExpandChat()
  If Not (ChatExpanded.FCheck()) Then
    Call skapi.MouseMove(skapi.dxpWindow - 318, skapi.dypWindow - 94)
    Call skapi.MouseButton(0)
    Call skapi.Sleep(100)
  End If
End Sub
Sub MouseClickMerchantTab(n)
  If (n < 1) Or (n > 3) Then Exit Sub
  Call skapi.MouseMove(230 - (92 * (3 - n)), (0.75 * height) - 161)
  Call skapi.MouseButton(0)
  Call skapi.Sleep(100)
End Sub
Sub MouseClickBuyItem()
  Call skapi.MouseMove(skapi.dxpWindow - 340, (0.75 * skapi.dypWindow) - 134)
  Call skapi.MouseButton(0)
  Call skapi.Sleep(100)
End Sub
Sub MouseClickAddToList()
  Call skapi.MouseMove(skapi.dxpWindow - 340, (0.75 * skapi.dypWindow) - 102)
  Call skapi.MouseButton(0)
  Call skapi.Sleep(100)
End Sub
Sub MouseClickSellAll()
  Call skapi.MouseMove(skapi.dxpWindow - 340, (0.75 * skapi.dypWindow) - 102)
  Call skapi.MouseButton(0)
  Call skapi.Sleep(100)
End Sub
Sub MouseClickMerchantCategoryButton()
  Do Until (CurrentSelectionOK())
    Call skapi.Sleep(50)
  Loop
  If Handler.Warning Then Exit Sub
  Call skapi.MouseMove(113, (0.75 * skapi.dypWindow) - 136)
  Call skapi.MouseButton(0)
  Call skapi.Sleep(100)
End Sub
Sub MouseClickMerchantCategory(n)
  If (n < 1) Or (n > 12) Then Exit Sub
  Call skapi.MouseMove(55, (0.75 * skapi.dypWindow) - 136 + (18 * n))
  Call skapi.MouseButton(0)
  Call skapi.Sleep(100)
End Sub

sub NavigateWorkplace()
  If WorkplaceLB = MainPack.maploc.landblock then exit sub
  select case WorkLocation
    case 1: WorkplaceLB = HealerLB
            exit sub
    case 2: NavigateHouse()
    case 3: NavigateMansion()
  end select

end sub

sub NavigateHouse()
  Dim lb, ct
  lb = MainPack.maploc.landblock
  ct = 0
  Do
    Call skapi.Keys("{Return}")
    Call skapi.PasteSz("/house recall")
    Call skapi.Keys("{Return}")
    Call skapi.WaitEvent(90000, 2, 18)
    Call skapi.WaitEvent(1000)
    If (MainPack.maploc.landblock = lb) Then
      If (ct < 3) Then
        Call skapi.OutputLine("It doesn't look like I went anywhere.  I'll try again.")
        ct = ct + 1
      Else
        Call skapi.OutputLine("It doesn't look like I went anywhere, but I'll proceed anyway.")
        Exit Do
      End If
    End If
  Loop Until (MainPack.maploc.landblock <> lb)
  If UseWorkplaceRoute then UseRouteFile "Workplace.route"
  if WorkplaceLB = &H0000000& then WorkplaceLB = MainPack.maploc.landblock
end sub

sub NavigateMansion()
  Dim lb, ct
  lb = MainPack.maploc.landblock
  ct = 0
  Do
    Call skapi.Keys("{Return}")
    Call skapi.PasteSz("/house mansion_recall")
    Call skapi.Keys("{Return}")
    Call skapi.WaitEvent(90000, 2, 18)
    Call skapi.WaitEvent(1000)
    If (MainPack.maploc.landblock = lb) Then
      If (ct < 3) Then
        Call skapi.OutputLine("It doesn't look like I went anywhere.  I'll try again.")
        ct = ct + 1
      Else
        Call skapi.OutputLine("It doesn't look like I went anywhere, but I'll proceed anyway.")
        Exit Do
      End If
    End If
  Loop Until (MainPack.maploc.landblock <> lb)
  If UseWorkplaceRoute then UseRouteFile "Workplace.route"
  if WorkplaceLB = &H0000000& then WorkplaceLB = MainPack.maploc.landblock
end sub


Sub NavigateHealer()
  If (MainPack.maploc.landblock <> HealerLB) Then
    Call skapi.OutputLine("Going to healer.")
    Call GoToHealer()
  End If
End Sub

Sub NavigateArchmage()
  If (MainPack.maploc.landblock <> ArchmageLB) Then
    Call skapi.OutputLine("Going to archmage.")
    Call GoToArchmage()
  End If
End Sub

Sub UseRouteFile(name)
  Call RouteFromFile(name).Go()
End Sub

Sub UsePortal(name)
  Dim lb, obj, r, ct
  lb = MainPack.maploc.landblock
  ct = 0
  Do
    Set obj = skapi.AcoFromSz(name)
    If Not (obj Is Nothing) Then
      T.cmsec = 0
      Do
        Call obj.Use()
        r = skapi.WaitEvent(2000, 2, 17)
      Loop Until (r = 17) Or (T.cmsec > 20000)
      If Handler.Warning Then Exit Sub
      If (r = 17) Then Call skapi.WaitEvent(60000, 2, 18)
      Set obj = Nothing
    End If
    Call skapi.WaitEvent(1000)
    If (MainPack.maploc.landblock = lb) Then
      If (ct < 3) Then
        Call skapi.OutputLine("It doesn't look like I went anywhere.  I'll try again.")
        ct = ct + 1
      Else
        Call skapi.OutputLine("It doesn't look like I went anywhere, but I'll proceed anyway.")
        Exit Do
      End If
    End If
  Loop Until (MainPack.maploc.landblock <> lb)
End Sub

Sub GoToHealer()
  LifestoneRecall
  UseRouteFile "RithwicLStoHealer.route"
End Sub

Sub GoToArchmage()
  If Mainpack.maploc.landblock <> HealerLB Then GoToHealer
  UseRouteFile "RithwicHealerToRetreat.route"
  UsePortal "Martine's Retreat"
  UseRouteFile "RetreatToArchmage.route"
End Sub

Sub LifestoneRecall()
  Dim lb, ct
  lb = MainPack.maploc.landblock
  ct = 0
  Do
    Call skapi.Keys("{Return}")
    Call skapi.PasteSz("/lifestone")
    Call skapi.Keys("{Return}")
    Call skapi.WaitEvent(90000, 2, 18)
    Call skapi.WaitEvent(1000)
    If (MainPack.maploc.landblock = lb) Then
      If (ct < 3) Then
        Call skapi.OutputLine("It doesn't look like I went anywhere.  I'll try again.")
        ct = ct + 1
      Else
        Call skapi.OutputLine("It doesn't look like I went anywhere, but I'll proceed anyway.")
        Exit Do
      End If
    End If
  Loop Until (MainPack.maploc.landblock <> lb)
End Sub
